\documentclass[a4paper,10pt]{report}
\usepackage{ae,aecompl}
\usepackage[T1]{fontenc}
\pagestyle{plain}
\usepackage{graphicx}
\usepackage{moreverb}
\begin{document}

\title{Garbage Collection for JNuke, a Java Virtual Machine for Runtime Verification and Model Checking}
\author{Peter Farkas}
\maketitle

\setcounter{tocdepth}{1}
\tableofcontents
\listoffigures

\begin{abstract}
JNuke is a Java Virtual Machine (VM) designed for runtime verification and model checking.
It features operations to save the state of the VM and restore it later to follow a different path of execution
from there.
In other virtual machines, objects that are not reachable from the user program are eligible for garbage collection.
For JNuke this is not the case: Unreachable objects can become reachable again when the VM is reverted to a previous state.
Generational garbage collection is adopted, with the generations being separated by milestones.
Only objects created since the
last milestone are considered for garbage collection, as they cannot be referenced by previous states of the VM.
Consequently, a collection must be performed before every milestone but the cost is linear in the size of the new generation.
Garbage collection minimizes the memory footprint of the VM, improving the performance of model checkers. Furthermore,
runtime verification tools can run infinite programs.
\end{abstract}

\chapter{Introduction}\label{chp:intro}

Java is a garbage collected language. Java programs create objects on the heap but do not
explicitly destroy them. They depend on a garbage collector (GC) to reclaim objects
that are no longer referenced by the program. For \emph{JNuke} \cite{jnuke}, no GC has yet been implemented.

JNuke was designed to serve \emph{runtime verification} and \emph{model checking} algorithms.
Runtime verification algorithms run the user program once,
thus exploring one possible schedule. Model checkers, on the other hand,
explore all possible schedules.

For model checkers, JNuke provides two operations on the entire state of the VM:
setting \emph{milestones} and taking \emph{footprints}.
Setting a milestone pushes the state of the VM to a stack. The VM can later be reverted to the saved state.
Model checkers set milestones before the scheduler would (seemingly randomly) choose a thread to schedule.
From there, they explore the schedules resulting from any thread the scheduler might choose.

Footprints are mappings from VM states to strings of bytes. Model checkers keep a set of footprints
of visited states. They prune the current schedule if they discover the footprint of the current state in the set.
Unfortunately, equal VM states may map to different footprints,
thus model checkers may still visit the same state several times.

With garbage collection, the size of the heap would decrease. For runtime verification, where
the memory usage of the VM primarily depends on the size of the heap, much larger, even infinite
programs could be executed without running out of memory.

With model checking, the number of VM states grows exponentially with the length of the program.
Thus, not the size of the heap, but the size of the set of footprints determines the memory usage.
With garbage collection, footprints would become smaller, as the heap is contained in the footprints.
Presumably, the number of footprints would decrease, because garbage on the heap cannot
make the difference between two otherwise
equal footprints. With fewer footprints,
model checkers would be more likely to discover that they have already seen a state.

In implementing garbage collection, milestones pose an interesting challenge: In other virtual machines,
objects that are not reachable from the user program are eligible for garbage collection.
But with milestones, unreachable objects can become reachable again when the VM is rolled back to a previous state.

In addition, verification algorithms can refer to data no longer referenced by the VM, either by the current state
or by previous states. Verification algorithms must protect their data from the GC.

\section{Objectives}

The objectives are:
\begin{description}
\item[Garbage collection:] Solve the problems posed by milestones and external algorithms and implement
garbage collection for the JNuke VM.
\item[Adapt the existing algorithms] so they protect their data from the GC.
Show that they sufficiently protect their data.
\item[Measure] the performance of the GC in terms of overhead and decrease in the size of the heap. Find out if
footprints actually merge, as predicted in the last section.
\end{description}  

\section{Preliminaries}

\subsection{JNuke}

JNuke \cite{jnuke}, written in C, was designed to serve verification algorithms.
The algorithms, also written in C, are implemented as listeners to the VM.
When notified, they analyze the state of the VM through its well-documented interface.
The VM consists of several self-contained subsystems, as shown in figure \ref{fig:subsystems}.

\begin{figure}
\begin{center}
\includegraphics{pics/subsystems}
\end{center}
\caption{Subsystems of the VM}\label{fig:subsystems}
\end{figure}

The \emph{runtime environment} drives execution of the Java byte code. It processes the instructions of
the user program, delegating most of the work to the subsystems. The runtime environment does not have a
scheduler and therefore cannot run multi-threaded programs directly.

The \emph{scheduler} is a listener to the runtime environment.
Before executing an instruction, the runtime environment notifies the scheduler, which, in turn, may decide
to schedule another thread. The idea behind this design is that
verification algorithms can replace the built-in scheduler.

The \emph{heap manager} manages \emph{Java instances}. Java instances can either be \emph{class instances}
or \emph{object instances}.
Class instances store class variables, static fields in Java language. The VM creates one
class instance for every loaded class. Object instances store the instance variables, non-static fields
in Java language. The VM creates one object instance on the heap for every object created by
the user program. Object instances, in turn, are either objects or arrays. The heap manager provides
operations for creating and manipulating Java instances.

The \emph{lock manager} and the \emph{wait set manager} provide to primitives of thread synchronization.
In Java, threads synchronize through \emph{synchronized sections}. A method declared as \texttt{synchronized}
is executed under mutual exclusion: Only one thread at a time can be executing any of the \texttt{synchronized}
methods of an object.

To enter a synchronized section, a thread must acquire the \emph{lock} associated
with the object. If the lock is already taken by another thread, the entering thread is delayed
until the other thread releases the lock either by leaving the synchronized section or by invoking \texttt{wait}.
The lock manager provides operations for acquiring and releasing locks.

Invoking \texttt{wait} causes the current thread to wait until either another thread invokes
\texttt{notify} and the thread is arbitrarily chosen as the thread to be awakened or the other thread
invokes \texttt{notifyAll}. The wait set manager provides
the functionality for \texttt{wait}, \texttt{notify} and \texttt{notifyAll}.

Every Java object has two associated waiting queues: one for threads waiting for monitor entry and one for
threads sleeping on the object. The queues are managed by the lock manager and the wait set manager,
respectively.

\subsubsection{Milestone-rollback mechanism}

The \emph{milestone-rollback mechanism} allows model checkers to explore all schedules of a Java program.
It consists of three operations: \texttt{setMilestone} saves the state of the VM
to a stack; \texttt{rollback} reverts the VM to the state on top of the stack; \texttt{removeMilestone} discards the last
state saved.

Model checkers set milestones before the scheduler would (seemingly randomly) choose a thread to schedule.
From there, they execute the schedules resulting from any thread the scheduler might choose, repeatedly
rolling back to the milestone. When there are no more threads to schedule, the milestone is removed.

Model checkers access the milestone-rollback mechanism through the runtime environment.
The runtime environment maintains a stack of shallow clones of itself, i.e. the elements contain data
of the runtime environment
(e.g. the number of active threads), but not the data of the subsystems.
The subsystems maintain their own stacks. The lock manager and the heap manager stack clones,
similar to the runtime environment.

For the heap manager, however, stacking clones (containing the Java heap), would cost
too much memory. Therefore, it only stacks differences between milestones. When setting
a milestone, it creates a \emph{heap log}. Before the heap manager writes to a field, the heap log registers
the address of the field, its size and old value. At rollback, the heap log writes the saved values back to the heap.

\subsubsection{Footprints}

Operation \texttt{freeze} maps the state of VM to a \emph{footprint}, a string of bytes.
Model checkers keep a set of footprints of visited states to avoid visiting the same VM state twice, thus
pruning their search space. Model checkers call \texttt{freeze} on the runtime environment, which
propagates the call to the subsystems.

Footprints are only used for comparison, and thus contain less data than milestones. For instance, they do not
contain the locks owned by the threads. Recording which locks a threads has acquired would be redundant,
as they are deducible from the current position of thread in the methods it is calling.

\subsection{Algorithms}

JNuke supports \emph{runtime verification} and \emph{model checking} algorithms. The behavior of a multi-threaded program
depends on the input and on the schedule dictated by the scheduler. Runtime verification tools monitor a program
for one particular input and an arbitrary schedule. Model checking tools, on the other hand,
monitor the program exploring all possible schedules for all possible inputs. JNuke \cite{jnuke} is an
\emph{explicit-state} (as opposed to symbolic \cite{bmc}) model checker.

Verification algorithms for JNuke are listeners to the VM. They register to events of interest
at the subsystems of the VM.
Runtime verification algorithms run the VM with the built-in round-robin scheduler. 
The runtime verification algorithms implemented for JNuke
are \emph{Eraser} \cite{eraser}, \emph{View Consistency} \cite{vc} and \emph{Block-local Atomicity} \cite{bla}
(not covered because it was only implemented toward the end of this thesis).
Model checkers discard the built-in scheduler and assume scheduling themselves.
The only model checker for JNuke is based on the \emph{ExitBlock} \cite{eb} heuristics for state
space exploration.

\begin{description}
\item[Eraser] \cite{eraser} detects \emph{low-level data races}.
A low-level data race can occur when a shared field is not
consistently protected by a common lock \cite{vc}. Nothing prevents more than one thread to access the field simultaneously.
Eraser enforces the \emph{mutual exclusion locking discipline} that shared variables are protected by some lock
\cite{eraser}.
\item[View Consistency] \cite{vc} detects \emph{high-level} data races, assuming the program is free
from low-level data races. High-level data races occur
if the program behaves incorrectly because operations that should be carried out
atomically can be interleaved with conflicting operations.
The basic definition is as follows:
\begin{quote}
A high-level data race can occur when two concurrent threads access a set $V$ of shared variables,
which should be accessed atomically, but at least one of the threads does not access the variables in $V$ atomically
\cite{vc}.\end{quote}
\item[ExitBlock] \cite{eb} explores all possible schedules of the user program, discovering assertion
violation and deadlocks. It does not need to interleave each statement of each thread with each statement
of all other threads: If the user program follows the mutual exclusion locking discipline,
interleaving all \emph{atomic blocks} suffices to cover all possible behaviors of the user program.
An atomic block consists of the code in between the ends of synchronized blocks.
ExitBlock explores schedules in a depth-first search manner, thus requiring threads to terminate.

Still, the number of schedules increases exponentially in both the number of threads
and the number of atomic blocks. An optimization for ExitBlock is to monitor
field accesses and not to reorder atomic blocks that do not share data.
This variant is called \emph{ExitBlock-RW}.
For ExitBlock-RW, the number of schedules in the average case is exponential in the number of threads but
polynomial in the number of atomic blocks.

Another optimization that can be switched on is to keep footprints of visited states
to prune the search space.
\end{description}

\section{Outline}
Chapter \ref{chp:mark_sweep} introduces the mark-sweep garbage collection algorithm.
Chapter \ref{chp:analysis} deduces a strategy for the GC based on an analysis of the problems posed by external heap
references and rollback.
Chapter \ref{chp:gc} covers the design of the GC and the changes to the VM.
Chapter \ref{chp:adaptation} discusses the adaptations to the algorithms.
Chapter \ref{chp:experiments} validates both the effectiveness and the correctness of the implementation.
Chapter \ref{chp:future} presents future work.
Chapter \ref{chp:conclusion} concludes.

\chapter{The mark-sweep algorithm}\label{chp:mark_sweep}

This chapter presents different garbage collection algorithms and explains why mark-sweep will be implemented for
JNuke. Then, it discusses whether to unload classes and when to trigger a collection.

\section{The classical algorithms}

Richard Jones distinguishes between three types of garbage collection algorithms \cite{jones}:

\subsection{Reference counting}

Every object stores the number of references to it, the \emph{reference count}. When an object is created, its reference
count is set to one. Each time a reference is set to refer to this object, the counter is increased;
when a reference to the object is deleted, the counter is decreased. If this causes the reference count
to drop to zero, the GC reclaims the object.

The strength of the reference counting algorithm is that the overhead for garbage collection is distributed
throughout the computation. The user program is not suspended for a long time. Reference
counting may therefore be suitable where response time is important (e.g. in highly interactive systems).

The major drawback of simple reference counting is its inability to reclaim cyclic
data structures. Cyclic data structures are frequently used in Java programs. As an example,
consider the data structure shown in figure \ref{fig:cyclic}
representing a doubly-linked list. Suppose that the reference to the list is deleted. The reference
count of the links remains non-zero and the list is not garbage collected.

\begin{figure}
\begin{center}
\includegraphics{pics/cyclic}
\end{center}
\caption{Cyclic data structure}\label{fig:cyclic}
\end{figure}

\subsection{Mark-sweep}\label{sec:mark_sweep}

Under this scheme, objects are not reclaimed immediately when they become garbage, but remain undetected
until the heap is exhausted. If a request is then made for a new object, the user program
is suspended while the garbage collector collects the currently unused objects.

Mark-sweep garbage collection is performed in two phases. The \emph{mark phase} identifies all live objects.
A \emph{mark bit} associated with each objects indicates whether the object was found to be reachable.
This trace starts from the \emph{root set}. The root set includes all pointers outside the
garbage collected area that could point inside it i(e.g. the Java registers in the VM).

In the mark phase, the elements of the root set are considered one by one. First they are pushed on
the \emph{mark stack}. Then their descendants are marked by the algorithm in figure \ref{fig:mark}.
Note that objects are marked before pushing them on the mark stack and children are only pushed if they are unmarked.
With this strategy, the algorithm visits every live object exactly once.

\begin{figure}
\begin{verbatim}
while (o = pop (markStack) {
  while ([o has more reference fields]) {
    c = [next reference fields];
    if (!IS_MARKED (c)) {
      MARK (c);
      push (markStack, c);
    }
  }		
}
\end{verbatim}
\caption{Algorithm for descendant marking}\label{fig:mark}
\end{figure}

The \emph{sweep phase} iterates through all objects in the garbage collected area,
reclaiming unmarked objects and unmarking
marked objects in preparation for the next collection. Mark-sweep handles cycles naturally,
no special precautions need to be taken.

\subsection{Copying garbage collection}

Copying garbage collectors divide the heap equally into two \emph{semi-spaces}. Memory is allocated
only in the active semi-space. When triggered, the GC traverses the active data structure in the old semi-space,
\emph{from-space}, copying each
live object into the new semi-space, \emph{to-space}, when the object is first visited. A pointer to
the copy is established.
After all live objects have been traced, a replica of the active data structure has been created in to-space
(see figure \ref{fig:copying}), which
then becomes the active semi-space.

\begin{figure}
\begin{center}
\includegraphics{pics/copying}
\end{center}
\caption{Replica of from-space in to-space}\label{fig:copying}
\end{figure}

The advantage of copying garbage collecting over reference counting and mark-sweep is that fragmentation is eliminated
by compacting the active data into to-space. Allocation costs are extremely low: New objects are just
created adjacent to the other objects in the active semi-space. Reference counting
and mark-sweep do not compact the heap. Allocation costs are much higher \cite{jones}.

Unfortunately, in JNuke, objects cannot be moved. First, the heap log (where JNuke registers changes
to the heap for rollback; see chapter \ref{chp:intro}) contains heap references. Second, verification algorithms
hold heap references. Both the heap log and the algorithms assume that data is not moved.

\section{Evaluation}

For JNuke, mark-sweep GC was implemented. Reference counting cannot inherently handle cycles.
Data cannot be moved, as for copying collection, due to heap references from the
heap log and verification algorithms.

Because objects do not have to be allocated at a specific address (as for copying collection,
where objects have to be allocated adjacent to the other objects in the active semi-space),
garbage collection can be implemented on top of memory management for JNuke.
The only action performed by the garbage collector is to call \texttt{JNuke\_free}.

\section{Class unloading}

A decision has to be made whether only data representing Java objects or data for Java classes should be garbage
collected, as well.

When loading a class, triggered by (among other events) creating the first object of the class,
the class descriptor in the \emph{method area} (storage area for per-class structures)
and the class instance on the heap are created
(see figure \ref{fig:method}). The class descriptor contains, among other things,
the byte codes for the methods and a reference to the class instance (storing class variables).

\begin{figure}
\begin{center}
\includegraphics{pics/method}
\end{center}
\caption{The heap and the method area}\label{fig:method}
\end{figure}

Garbage collection could be extended to the method area. When no more instances of a class exits, the class
could be unloaded by removing the class descriptor from the method area and the class instance from the heap.

Unloading classes reduces the size of the VM for programs employing large classes. On the other hand,
classes might have to be loaded again, imposing a time overhead. JNuke programs employ small classes. Furthermore,
the method area is not part of the footprints. Therefore, JNuke should not unload classes
and only object instances are subject to garbage collection.

\section{When to trigger}

The heap is expanded as required by the computation and contracted if a larger heap becomes unnecessary.
On a virtual memory architecture, there is no point in
fixing the size of the heap.

There is a trade-off between a small heap and few collections.
A small heap yields better locality of reference. On the other hand,
the cost of a collection is proportional to the size of the heap,
independent of the number of objects reclaimed.

The decision about how  often to collect is captured by a number, called the \emph{heap size factor}
(set at compile time).
The GC is triggered when the data subject to garbage collection exceeds a dynamic limit.
After collection, the limit is set to the amount of live data times the heap size factor.
With this policy, the garbage collectible data is limited to the live data times the heap size factor
(with a minimal number of collections).

If the heap size factor is <= 1, every creation of
an object instance triggers a collection. If it is infinite, garbage collection is never triggered.
The default value is 2, thus the size of heap is limited to the amount of live data times 2.
The GC can also be triggered explicitly as discussed in the next chapter.

\section{Summary}

A mark-sweep GC was implemented. A collection is performed in two phases: In the mark phase, all objects
reachable from the root set are marked. In the sweep phase, unmarked objects are reclaimed.
Object instances, but not data for classes, are subject to garbage collection.
The GC is triggered when the size of the heap exceeds a dynamic limit and the limit is set to
the amount of data left times the heap size factor.

\chapter{Analysis}\label{chp:analysis}

This chapter deduces a strategy for the GC based on an analysis of the problems posed by external heap
references and rollback. The strategy is then adopted for JNuke.

\section{Protecting objects}\label{sec:protection}

Verification algorithms can refer to object instances no longer referenced from the user program.
As a device for verification algorithms to protect their data from the GC,
\emph{indestructible} objects have been introduced.

When verification algorithms establish a reference to an object, they \emph{protect} the object,
and when deleting the reference, they \emph{release} it.
Protected objects are indestructible by the GC: In the sweep
phase it saves objects if they are either marked or protected.

A \emph{protection level}, rather than just a boolean flag, is associated with each object.
Protecting and releasing an object increases and decreases its
protection level, respectively. An object is considered protected if its protection level is greater than zero.

With protection levels, the adaptations to the algorithms were simpler than with just a protected bit.
For example, Eraser protects the associated object when recording a lock in a candidate set (see chapter
\ref{chp:adaptation}). The protection level is the number of candidate sets of which the lock is part.
When excluding locks from the candidate set, it releases them without having to check if they appear
in another candidate set.

An alternative to protecting single objects would have been to extend the root set by the objects
to be protected. However, descendants would also have been protected, which is never necessary
(see chapter \ref{chp:adaptation}).

\section{Rollback}

JNuke maintains a stack of milestones representing previous VM states.
When rolling back to a previous state, it is possible that objects that were unreachable from the current state
become reachable again.

Consider the code in figure \ref{fig:rollback}. The object created in line 1 is not
reachable after line 2. But when rolling back, it becomes reachable again.
Suppose a collection was performed after line 2 and the GC did not look at milestones.
It would miss the object in
the mark phase and destroy it in the sweep phase. After rollback, \texttt{ref} would be a dangling reference.

\begin{figure}
\begin{verbatim}
1 ref = new C ();
// set milestone
2 ref = null;
// collection
\end{verbatim}
\caption{An object unreachable from the current state but reachable from the previous state}\label{fig:rollback}
\end{figure}

One strategy would be to extend the root set with the roots of VM states saved in the milestones. In this example,
the value of \texttt{ref} before the milestone would be part of the root set. The object created in line 1 would be saved.
Descendant marking would also change. The children of an object would not only be the objects it currently references
but also those it has referenced when milestones were set. Old field values would have to reconstructed from the heap log.

Fortunately, there is a much simpler strategy. Instead of marking more objects, fewer objects are swept:
only those created since the last milestone. This implies that the GC
has to be triggered explicitly before setting a milestone. As discussed in the next section, those frequent collections
can be efficiently implemented.

The strategy is optimal: As many objects as possible are collected. Every instance that survives a collection
is reachable from the milestone that triggered the collection.
The strategy is also correct: No dangling pointer is created. Currently reachable objects are marked as they are
reachable from the current root set. No reference from a milestone to the garbage collected area can exist,
because those objects did not exist when the milestone was set.

\section{Generational garbage collection}

Generational Garbage Collection is an optimization of mark-sweep. It is based on the observation that
"most objects die young" \cite{ungar}.
The GC is more likely to find recyclable objects among the new ones.
The heap is segregated into two or more \emph{generations}. An object is
born into the \emph{new generation}. If it survives sufficiently many collections
it gets transferred to the next generation. The new generation is then collected most often.

When collecting the new generation, both the sweep and the mark phase operate over only new
objects. In the mark phase, old objects are not traversed. Consequently, new objects only reachable through old objects
are not reachable from the root set for non-generational garbage collection.
The root set must be extended by \emph{inter-generational references} (see figure \ref{fig:inter}).
The GC monitors accesses to reference fields. If a field of an old object is
set to refer the to a new object, either the whole object or the field is inserted in the
\emph{remembered set}. The remembered set is part of the root set.

\begin{figure}
\begin{center}
\includegraphics{pics/inter}
\end{center}
\caption{Inter-generational reference}\label{fig:inter}
\end{figure}

In JNuke, a collection over objects created since the last milestone must be performed before setting a milestone.
Generational garbage collection can be adapted to make those frequent collections over few objects efficient.
Generations are defined by milestones.
Unlike for conventional generational garbage collection,
older generations are never collected (until after sufficiently many milestones have been removed and
they become the new generations again). Furthermore, objects that survive a collection are not transferred
to an older generation.

As for conventional generational garbage collection, collections over the new generation are efficient.
A non-generational mark-sweep GC visits every live object in the mark phase exactly once
(see chapter \ref{chp:mark_sweep}), and every object in the sweep phase.
The cost for a collection is proportional to the number of objects on the heap.
A generational GC collecting the new generation only marks and sweeps objects in the new generation.
Additionally, in the mark phase it iterates through the inter-generational references.
But as inter-generational references are rare \cite{appel}, that extra cost is ignored.
The cost for a collection is linear in the size of the new generation.
Frequent collections over few objects do not degrade the performance of the GC.

\section{Pointers}

Having deduced the basic strategy, the next step is to adopt the strategy for JNuke.
For the following discussion, \emph{blue} refers to data eligible for garbage collection and \emph{red} to data not
eligible for garbage collection.

Figure \ref{fig:blue_red} depicts all possible connections between blue and red data in JNuke.
Note that no red to blue pointers from the algorithms exist, because algorithms protect their data.
When an object is destroyed, two kinds of pointers are affected:
blue to red, and red to blue. Blue to blue pointers cannot exist: If two objects are eligible for garbage collection,
both are considered in the mark phase; if the source object is marked, the destination object is also marked, thus
survives the collection. Red to red pointers are not affected when destroying blue data.

\begin{figure}
\begin{center}
\includegraphics{pics/blue_red}
\end{center}
\caption{Connections between blue and red data}\label{fig:blue_red}
\end{figure}

If a red to blue pointer is destroyed, a \emph{dangling pointer} results. Those pointers either have to be made
part of the root set (see section \ref{sec:root_set}) or the red data has to be removed with the blue data
(see section \ref{sec:destroy}). If a red to blue pointer is destroyed, a \emph{memory leak} can result.
A memory leak occurs when red data becomes superfluous without the blue data but is freed much later than the blue data.
The red data has to be freed with the blue data (see section \ref{sec:destroy}).

\section{Root set}\label{sec:root_set}

As figure \ref{fig:blue_red} shows, red to blue pointers exist from both
inside and outside the heap.
Pointers inside the heap are references from class instances and inter-generational references.
They must be include in the root set. Protected objects are not roots, since their
descendants need not be protected (see section \ref{sec:protection}).

To find possible red to blue pointers (roots) from the VM,
all classes of the JNuke VM that may hold red to blue pointers are discussed.
For each case, a decision is made whether to included the pointers in the root set or to remove the red data
holding the pointer.
\begin{description}
\item[JNukeStackFrame] contains the Java registers. Registers may point to blue data, and thus are included
in the root set.
\item[JNukeLock] references the Java object through which the user program access the lock.
\texttt{JNukeThread} and \texttt{JNukeLockManager} have pointers to \texttt{JNukeLock}.
\item [JNukeLockManager] contains all locks. Every object that is used as monitor has
an entry in the lock manager. The lock
is only accessible through the Java object. If it has become unreachable, the entry for
the lock should be removed. The lock should be freed (see the next section).

An alternative to destroying locks when objects are garbage collected could be to
destroyed them when all threads have left the monitor.
The reason why this not done is that it might have to be recreated for a new thread entering the monitor.
\item [JNukeWaitSetManager] associates objects with wait sets. Every object that is a monitor
with threads waiting in the monitor has an entry in the wait set manager.
The wait set is accessible only through the Java object. If it has become unreachable,
the entry for the wait set should be removed. The wait set should be freed (see the next section).

Like locks, wait sets are freed when objects are garbage collected to avoid creating the wait set for
the same object twice.
\item[JNukeThread] holds a reference to the Java object, which represents the thread. If the thread was created
since the last milestone, the thread object is blue data. However, the thread object
is needed (even if it is not referenced)
in order to support the \texttt{currentThread()} and \texttt{enumerate()} methods of the
\texttt{Thread} class. Thread objects must be included in the root set.

Furthermore, if the thread waits in a monitor it holds a reference to the lock
it must reacquire when it wakes up. That reference needs not be root. The object is also reachable from the
registers of the thread, as it called the native method \texttt{wait}.
\item[JNukeRuntimeEnvironment:] When the VM encounters a string constant in the user program, it creates the corresponding
Java \texttt{String} on the heap.
The Java Language Specification (Second Edition, section 3.10.5) requires that two references to Java \texttt{Strings},
that where initialized with the constant, must be equal.
To satisfy this requirement, the runtime environment maintains a map of constants to
string objects. Before creating the objects for a constant,
it checks whether the object already exists in the map.

String objects can safely be garbage collected.
Although the same constant will then result in a different objects before and after the collection,
different references for the same constant cannot exist. If a reference to the string before
the collection existed, it would have survived the collection.
\item[JNukeHeapManager] has a reference to every object instance. One vector contains all objects,
the other all arrays. The GC iterates through these vectors in the sweep phase.
References from the vectors are removed, not included in the root set.
\end{description}
The root set consists of pointers from class instances, inter-generational references, registers and references
to thread objects.

\section{Destroying objects}\label{sec:destroy}

Before destroying blue data, the GC must remove red data to avoid dangling references or
memory leaks. This section focuses on memory leaks.

Java instances in JNuke are of type \texttt{JNukeJavaInstanceHeader}
(figure \ref{fig:header}). When allocating memory for a \texttt{JNukeJavaInstanceHeader}, more memory
than the size of the struct is allocated. In the extra space, the Java fields are stored.
Java objects are potentially blue data. 
To find red data that must be freed with the object, every pointer from Java instances is examined.

\begin{figure}
\begin{verbatim} 
struct JNukeJavaInstanceHeader
{
  JNukeObj *instanceDesc;
  JNukeObj *lock;
  JNukePtrWord arrayLength;
  JNukeObj *waitSet;
};
\end{verbatim}
\caption{Type of Java instances}\label{fig:header}
\end{figure}

\begin{description}
\item[Java fields] either reference objects of the new generation (blue to blue) or objects of older generations.
Objects of older generations are in use by previous states of the VM, saved in the milestones.

\item[instanceDesc] is the pointer to class descriptor in the method area.
In chapter \ref{chp:mark_sweep}, the decision was made not to free the class descriptor, even
if the instance being destroyed is the last instance of the class.

\item[lock] points to the lock of the object.
Since the lock is only accessible through the Java object (which
has become unreachable), the lock is freed to avoid memory leaks.

No thread owns or waits for the lock, otherwise the object would be reachable from the registers.
If the thread acquired the lock by calling a \texttt{synchronized} method, it would have to be passing the reference
on the stack. If it acquired the lock by executing \texttt{monitorenter}, the lock would have to be available for a later
\texttt{monitorexit}.

(The last section concluded that the entry for locks in the lock manager must be freed.)
\item[waitSet] points to the wait set (threads waiting in the monitor) of the object.
Since the wait set is only accessible through the Java object (which
has become unreachable), the wait set is freed to avoid memory leaks.

The wait set is empty, otherwise the object would be reachable from the registers. A thread would
have to be passing the reference to native method \texttt{wait}.

(The last section concluded that the entry for wait sets in the wait set manager must be freed.)
\end{description}

\section{Summary}

Verification algorithms protect their data from the GC by making objects indestructible.
Only objects created since the last milestone are considered for garbage collection, which implies that the
GC must be triggered before every milestone. Generational garbage collection is adopted to make those frequent
collections efficient. When destroying an object, its associated data in the runtime environment,
the lock manager and the wait set manager must be removed.

\chapter{Garbage collection for JNuke}\label{chp:gc}

This chapter discusses the necessary changes to the JNuke VM to make garbage collection possible. Then, it
covers the design of the GC itself.

\section{Changes to the VM}

\subsection{Extension of the instance header}

Struct \texttt{JNukeJavaInstanceHeader} was extended by a word. The size of the header must
be a multiple of the pointer size because Java fields have to be word-aligned.
The GC uses it as depicted in figure \ref{fig:word}.
The mark bit indicates whether an object was found to be reachable in the mark phase.
The protection level is set by verification algorithms protecting and releasing objects.
An object survives a collection if it is either marked or protected. 

\begin{figure}
\begin{center}
\includegraphics[width=\textwidth]{pics/word}
\end{center}
\caption{Word of the instance header for the GC}\label{fig:word}
\end{figure}

The \emph{generation} of objects allows the GC to detect inter-generational references. The \emph{inter-bit}
indicates whether an object is already part of the remembered set (known to hold inter-generational references).
Through the inter bit, the GC avoids duplicates without looking up objects in the remembered set.

\subsection{Typed registers}

Java registers holding references are roots. The GC must mark all objects reachable from those
registers. However, registers do not carry type information.

\emph{Conservative garbage collectors}, implemented in Mono \cite{mono} and Kaffe \cite{kaffe},
treat every register
that holds the address of a heap object as a root. They risk misidentifying data as heap references, thereby
unnecessarily retaining objects that could otherwise be recycled.

Although only a few objects are erroneously retained in practice, those objects could
make up the difference between two footprints. That would not be in compliance with the ultimate
goal, that two logically equal VM states map to equal footprints.
Moreover, the behavior of conservative garbage collection is system-dependent, thus hard to test.
The GC for JNuke must be accurate.

The VM provides the necessary type information for the GC.
The Java register set of threads
was represented as an array of \texttt{JNukeRegister}. The array was replaced by a \texttt{JNukeRBox} object.
A \texttt{JNukeRBox} holds an array of \texttt{JNukeRegister}
for register values and a \texttt{JNukeBitSet} for \emph{reference bits}
(indicating whether the register is a reference).
The only way the write a register is to provide the reference bit as well.
It tells the GC whether or not to treat registers as roots.

\subsection{Containers where removal is efficient}

When an object is destroyed, the corresponding entries in the containers of \texttt{JNukeRuntimeEnvironment},
\texttt{JNukeLockManager}, \texttt{JNukeWaitSetManager}, and \texttt{JNukeHeapManager} must be removed.
Some of these containers were \texttt{JNuke\-Vector}s, implemented as resizable arrays.

For example, \texttt{JNukeLockManager} had a vector storing locks in the order they were created.
It used the vector, among other things, to clean up after rollback.
When setting a milestone, it saved the length of the vector. At rollback, it destroyed all locks
created since the last milestone. The only operations involved in this
were \texttt{push} and \texttt{pop}, insertion and removal from the tail of the vector.
Ignoring the cost of resizing the array, this operation takes constant time.

However, with garbage collection, when the GC destroys an object,
it demands the lock manager to destroy the lock and to remove the entry from the container.
The GC specifies the entry itself (a pointer to the lock), rather than the index; it does not know the index.
Sweeping through the containers (for objects and arrays) of the heap manager, it destroys objects in
the order they were created, not in the order locks were acquired for the objects.
For the lock manager, finding the lock in the vector would cost linear time.

The vector was replaced by a \texttt{JNukeSet}, implemented as a doubly linked list backed by a hash table.
Removing an entry specified by a pointer
costs constant time. \texttt{JNukeSet} was extended by the \texttt{uninsert} operation, which
removes the last element inserted.
Operations \texttt{insert} and \texttt{uninsert} replace \texttt{push} and \texttt{pop}.

All vectors in \texttt{JNukeRuntimeEnvironment} (managing Java string objects representing string constant),
\texttt{JNukeLockManager},
and \texttt{JNukeWaitSetManager}, where the GC demands to randomly
remove entries were replaced by sets. However, sets take (currently six times) more memory.
It is assumed that only a fraction of heap objects represent string constants,
are used as locks or have threads waiting on them.

However, the vectors
in the heap manager (referencing every heap object) were not replaced by sets. See section \ref{sec:gc}.

\subsection{VM protects its data}

Not only verification algorithms but also the VM itself must protect its data from the GC.

For instance, the runtime environment composes Java strings out of two parts: the string object itself and
the char array (see section \ref{sec:critical}). When the char array is created, the
string object is not yet written into the registers. If the creation of the char
array triggered the GC, it would destroy the string object. The string object must be protected
before creating the char array and released thereafter.

Errors related to insufficient protection, both by the VM and by verification algorithms, remain unobservable until
a collection actually takes place while there is unprotected data. To force those errors to occur, the test bench is
sometimes run in \emph{always GC} mode, where every object creation triggers a collection.

\subsection{Critical sections}\label{sec:critical}

The absence of critical sections was actually a bug that was found while implementing garbage collection.

The runtime environment maintains a map of constants to Java string objects (see chapter \ref{chp:analysis}).
Before creating a string object, it checks if it is not already in the map. String objects are garbage collected,
and their entries are removed from the map.

The runtime environment allocates the string object, converts the constant to a char array and finally runs the
constructor. The constructor is executed in the context of the
current thread, decreasing its time-to-live. With garbage collection, some string objects have to be recreated
that could otherwise be found in the map. Thus, garbage collection altered the schedules.

This discovery lead to the introduction of \emph{critical sections}.
Initialization of string objects and class initializers are
critical sections. In a critical section the time to live of the current thread is not decreased, and consequently,
no thread switch can take place. If thread switches could take place (as before the introduction
of critical sections), string objects and static variables could be accessed
before they are initialized, as illustrated in figure \ref{fig:before}.

\begin{figure}
\begin{center}
\includegraphics[width=\textwidth]{pics/before}
\end{center}
\caption{Accessing static field before it is initialized}\label{fig:before}
\end{figure}

\subsection{Options}

The following options are available:
\begin{description}
\item[GC]: Collect never (0), always (2) or sometimes (1). For debugging. "Sometimes" refers to the default
behavior. (See chapter \ref{chp:mark_sweep}).
\item[GENERATIONS]: Be generational (0) or non-generational (1). For debugging and profiling.
\item[CHECKS]: Should algorithms perform checking when the GC destroys an object (1) or not (0)?
Algorithms ensure that the object destroyed is not in use. See chapter \ref{chp:experiments}.
\end{description}

\section{Class GC}

This section describes the individual methods of class \texttt{JNukeGC}. They are grouped by the
classes that access them. The GC is accessed by the heap manager, the runtime environment and the
verification algorithms, as depicted in depicted in figure \ref{fig:relationship}.

\begin{figure}
\begin{center}
\includegraphics{pics/relationship}
\end{center}
\caption{Relationship of the GC to other classes}\label{fig:relationship}
\end{figure}

\subsection{Methods accessed by the heap manager}

The heap manager has no knowledge of the GC, but the GC listens to the heap manager for object creations and
field accesses.

Method \texttt{onCreation} triggers a collection when the amount of data on the heap exceeds a dynamic limit,
as described in chapter \ref{chp:mark_sweep}.
In addition, \texttt{onCreation} sets the generation of new objects to the number of milestones plus one.
The generation of static instances is never set, thus zero.
By counting from one, the GC can distinguish between class instances and object instances by their generation.

Method \texttt{onFieldAccessListener} records inter-generational references. An inter-generational reference is created,
if the source object is not a class instance (references from class instances are already roots), the destination
object belongs to the new generation and the source object does not.
When an inter-generational reference is detected, the object holding the reference is included in the remembered set
(part of the root set).

When setting a milestone, the GC can safely
remove the inter-generational references from the root set. If the new generation is empty, no inter-generational reference
can exist. Inter-generational references need not be recorded in the milestones if \texttt{removeMilestone} is
always followed by \texttt{rollback}, a policy that
is obeyed, but has never been documented. If \texttt{rollback} was allowed without \texttt{removeMilestone},
after \texttt{removeMilestone} inter-generational references would be lacking, see figure \ref{fig:lacking}.

\begin{figure}
\begin{center}
\includegraphics{pics/lacking}
\end{center}
\caption{Lacking inter-generational reference}\label{fig:lacking}
\end{figure}

\subsection{Methods accessed by the runtime environment}

The runtime environment just propagates calls the the milestone/rollback interface to the GC.
A GC milestone consists of the indexes of the first object and the first array of the new generation.

\subsection{Methods accessed by the verification algorithms}

Model checkers protect and release instances.

Additionally, they directly trigger the GC before taking a footprint of the VM. Alternatively, \texttt{setMilestone}
could automatically trigger a collection and \texttt{gc} be a private method. But as the ExitBlock algorithm
does not set a milestone if only one thread is ready to run but still takes a footprint, the decision was
made to decouple setting milestones and collections.

\subsection{Garbage collection}\label{sec:gc}

Figure \ref{fig:collection} shows the call graph of the methods involved in the collection.

\subsubsection{Mark}

To improve performance, no recursive procedure calls are made for descendant marking.
Instead, a \emph{mark stack} is used. Roots are marked and pushed onto the stack one by one.
Then, \texttt{markDescendents} repeatedly pops objects from the stack. For each object,
\texttt{push} marks unmarked children in the new generations and pushes them onto the stack.
It terminates when the stack is empty. The fact that \texttt{push} only pushes new
objects onto the stack is the reason why the cost for marking is
linear in the size of the new generation, rather than the size of the heap.

\begin{figure}
\begin{center}
\includegraphics[width=\textwidth]{pics/collection}
\end{center}
\caption{Call graph of methods for collection}\label{fig:collection}
\end{figure}

\subsubsection{Sweep}

In the sweep phase, the GC traverses the vectors of the heap manager (for objects and arrays).
Fortunately, as it knows the index of the entries being removed, it can replace them by entries from the tail
of the vector (where removal is efficient). See figure \ref{fig:trick}.

\begin{figure}
\begin{center}
\includegraphics{pics/trick}
\end{center}
\caption{Cleansing the heap manager}\label{fig:trick}
\end{figure}

One cursor scans the vector from left to right until it finds an entry pointing to garbage
(an object that is neither marked nor protected).
Then, another cursor scanning the vector from right to left traversed the vector until it finds a non-garbage entry,
removing garbage entries on its way. The object it finds replaces the garbage entry pointed to by the first cursor.
The algorithm terminates when the cursors cross. Its accumulated cost for all objects in the garbage collected area
is linear in its size. Thus, the cost for a single object is constant.

\section{Summary}

Typed registers were introduced to tell the GC whether or not to treat registers as roots.
Containers in the VM that were implemented as vectors were replaces by set to make
removal (demanded by the GC) efficient.
The GC listens to the heap manager for object creations and field accesses. Object creation might
trigger a collection. The GC offers model checkers methods to protect and release objects.
Furthermore, model checkers can trigger the GC externally to collect before footprints.

\chapter{Adaptation of the verification algorithms}\label{chp:adaptation}

Verification algorithms may refer to heap objects no longer reachable from the user program.
If the GC destroys those objects, a dangling reference is created. Dereferencing the reference
is an illegal memory access.

Furthermore, dangling references can lead to miscalculations when comparing them.
For instance, the pointers in figure \ref{fig:different} are different, but in
\ref{fig:possibly_different}, where \texttt{a} is a dangling pointer,
the logically different pointers may be equal if the memory
manager assigns the address of \texttt{a} to \texttt{b}.

\begin{figure}
\begin{verbatim}
  a = malloc (...);
  b = malloc (...);
  if (a == b) {
    ...
\end{verbatim}
\caption{Different references}\label{fig:different}
\end{figure}

\begin{figure}
\begin{verbatim}
  a = malloc (...);
  free (a)
  b = malloc (...);
  if (a == b) {
    ...
\end{verbatim}
\caption{Possibly different references}\label{fig:possibly_different}
\end{figure}

Illegal memory accesses can safely be detected with Valgrind, but no tool
(to the author's knowledge) can detect comparison of dangling references.

\section{Eraser}

The simplest version of Eraser \cite{eraser} enforces the simple \emph{mutual exclusion locking discipline}, that any shared
variable is protected by some lock.

Eraser maintains a map of fields to \emph{candidate sets}, the set of locks that potentially protect the field.
When a is field is accessed for the first time,
its candidate set is initialized to the set of locks owned by the accessing thread.
At subsequent times, the candidate set is intersected with the lock set of the accessing thread. If the intersection
is empty, no lock consistently protects the field and Eraser issues a warning.

\subsection{Data structure}

A map of fields to \texttt{JNukeEraserInfo} stores the candidate lock set (see figure \ref{fig:eraser_data}).
Fields are represented by \emph{field descriptors}. In JNuke, field descriptors are interior to Java fields.
Besides the field descriptors, all references to the garbage collected area are in \texttt{JNukeEraserInfo}.

\texttt{JNukeEraserInfo} stores the candidate lock set (\texttt{lockSet}) for each field.
Past field accesses are recorded in \texttt{lastAccess} or \texttt{accessHistory}, depending
on the mode Eraser is in. They hold pointers to \texttt{JNukeFieldAccess}, and thus references to the collected area.

Candidate lock sets are represented by sets of \texttt{JNukeLockInfo}. A \texttt{JNukeLock\-Info} consists of
just a \texttt{JNukeLock}. A lock has a reference to the heap object. Protecting the heap object protects the lock.

\begin{figure}
\begin{center}
\includegraphics{pics/eraser_data}
\end{center}
\caption{Pointers of Eraser to the garbage collected area}\label{fig:eraser_data}
\end{figure}

\subsection{Analysis}

Field descriptor objects are protected to avoid false positives. Consider the code in figure \ref{fig:eraser_fields}:
At the second field access, the candidate set of \texttt{a.x} consists of only \texttt{l}.
If \texttt{b} is assigned the address of \texttt{a}, Eraser thinks that lock \texttt{m} is now used to protect
\texttt{a.x}, and thus issues a warning.

\begin{figure}
\begin{verbatim}
sync (l) {
  a.x = 0;
}
// a gets garbage collected and replaced by b
sync (m) {
  b.x = 0;  // warning
}
\end{verbatim}
\caption{False positive because field object was not protected}\label{fig:eraser_fields}
\end{figure}

Locks are protected to avoid false negatives.
In the code of figure \ref{fig:eraser_locks},
if \texttt{l} gets the address of \texttt{m}, Eraser thinks that for the second access, again, \texttt{l} protects
\texttt{a.x}. Nevertheless, \texttt{l} and \texttt{m} are logically different.

\begin{figure}
\begin{verbatim}
sync (l) {
  a.x = 0;
}
// l gets garbage collected and replaced by m
sync (m) {
  a.x = 0;  // no warning
}
\end{verbatim}
\caption{False negatives because lock was not protected}\label{fig:eraser_locks}
\end{figure}

The histories (\texttt{lastAccess} and \texttt{accessHistory}) of
\texttt{JNukeEraserInfo} need not be protected.
Eraser creates clones of the field access objects and uses them only to generate warning messages.

\subsection{Measures}

The changes to the Eraser algorithm are listed in figure \ref{fig:eraser_diff}.

Field objects are protected when inserted in \texttt{accessInformation} (d1 in figure \ref{fig:eraser_diff})
and released (d3) when the program terminates.
The introduction of a new set was necessary to remember the objects (d1, d4).
Although only object instances are garbage collected, for simplicity,
both object and class instances are protected. Protecting a class instance has no effect.

Locks are protected when the candidate sets are set (d1 in \ref{fig:eraser_info_diff}).
When candidate locks are intersected with the lock set of the accessing thread, excluded locks are released (d2).
The \texttt{JNukeSet} was extended by the \texttt{difference} operation,
which returns the elements that would be excluded by \texttt{intersect}.
At program termination, the remaining objects of the remaining locks are released (d3).

\begin{figure}
\begin{verbatim}
d1 (struct JNukeEraser)
>   /* set of all instance that have to be released */
>   JNukeObj *instances;
d2 (JNukeEraser_fieldAccessListener)
>       /* protect instance */
>       if (JNukeSet_insert (eraser->instances, JNukeField_getInstance (field)))
>         {
>           JNukeGC_protect (JNukeField_getInstance (field));
>         }
d3 (JNukeEraser_delete)
>   it = JNukeSetIterator (eraser->instances);
>   while (!JNuke_done (&it))
>     {
>       JNukeGC_release (JNuke_next (&it));
>     }
>   JNukeObj_delete (eraser->instances);
d4 (JNukeEraser_new)
>   eraser->instances = JNukeSet_new (mem);
>   JNukeSet_setType (eraser->instances, JNukeContentPtr);
\end{verbatim}
\caption{Changes to \texttt{eraser.c}}\label{fig:eraser_diff}
\end{figure}

\begin{figure}
\begin{verbatim}
d1 (JNukeEraserInfo_addFieldAccess)
---
> 	  /* protect locks */
> 	  it = JNukeSortedListSetIterator (eraserinfo->lockSet);
> 	  while (!JNuke_done (&it))
> 	    {
> 	      JNukeGC_protect (JNukeLockInfo_getInstance (JNuke_next (&it)));
> 	    }
d2 (JNukeEraserInfo_addFieldAccess)
< 	JNukeSortedListSet_intersect (eraserinfo->lockSet, lockSet);
---
> 	{
> 	  /* release superfluous locks */
> 	  diff = JNukeSortedListSet_difference (eraserinfo->lockSet, lockSet);
> 	  it = JNukeVectorIterator (diff);
> 	  while (!JNuke_done (&it))
> 	    {
> 	      JNukeGC_release (JNukeLockInfo_getInstance (JNuke_next (&it)));
> 	    }
> 	  JNukeObj_delete (diff);
> 
> 	  JNukeSortedListSet_intersect (eraserinfo->lockSet, lockSet);
> 	}
d3 (JNukeEraserInfo_delete)
>   /* release remaining locks */
>   if (eraserinfo->lockSet)
>     {
>       it = JNukeSortedListSetIterator (eraserinfo->lockSet);
>       while (!JNuke_done (&it))
>         {
>           JNukeGC_release (JNukeLockInfo_getInstance (JNuke_next (&it)));
>         }
>     }
\end{verbatim}
\caption{Changes to \texttt{eraserinfo.c}}\label{fig:eraser_info_diff}
\end{figure}

\section{View Consistency}

View Consistency \cite{vc} gathers \emph{views} generated by the target program. A view is the set of fields
accessed by a thread while holding a lock (see figures \ref{fig:safe} and \ref{fig:high}).
At program termination, View Consistency checks whether the views conflict.

\begin{figure}
\begin{verbatim}
TO: sync (l) {
      p.x = 0;
      p.y = 0;
    }

T1: sync (m) {
      p.x = 0;
    }
\end{verbatim}

generates

\begin{verbatim}
V0: {p.x, p.y}
V1: {p.x}
\end{verbatim}
\caption{Code free of high-level data races}\label{fig:safe}
\end{figure}

\begin{figure}
\begin{verbatim}
TO: sync (l) {
      p.x = 0;
      p.y = 0;
    }

T1: sync (m) {
      p.x = 0;
    }
    sync (n) {
      p.y = 0;
    }
\end{verbatim}

generates

\begin{verbatim}
V0: {p.x, p.y}
V1: {p.x}, {p.y}
\end{verbatim}
\caption{A high-level data race}\label{fig:high}
\end{figure}

For the following discussion it is enough to understand that the program in
figure \ref{fig:safe} is free from high-level data races while the
the views generated by the program in figure \ref{fig:high} expose a high-level data race.
View Consistency assumes that \texttt{p.x} and \texttt{p.y} have to be accessed atomically,
because they are accessed atomically by T0.
However, as long as T1 in figure \ref{fig:safe} does not access \texttt{p.y} as well,
the access to \texttt{p.x} is perceived by T0 as atomic \cite{vc}.

View Consistency gathers views as follows: When a thread enters a monitor, it opens a new view for the thread.
When the thread accesses a field, it adds the field to open views for the thread.
When the thread exits the monitor, it closes the view.
Consistency checking is performed at program termination.

\subsubsection{Data}

Figure \ref{fig:vc_data} shows the relevant data.
The active views are stored in a vector of views for each thread.
The views consist of \texttt{JNukeFieldAccess}. Closed views are stored
in \texttt{viewsPerThread} and \texttt{maxViewsPerThread}.
Storing maximal views (maximal with respect to set inclusion in the views of the thread) is an optimization.
To find all incompatible views, it suffices to
compare the maximal views (rather than all views) of a thread with the views of each other thread.

A \texttt{JNukeView} contains the field accesses and the lock that was held by the accessing thread.
The lock does not play a role in the computation but it is accessed when generating warning messages.
View Consistency discards the lock set of \texttt{JNukeFieldAccess}.
Besides locks, the only pointers to the garbage collected
area from \texttt{JNukeView} are field descriptors.

To save memory, View Consistency avoidis duplicates of \texttt{JNukeField},
\texttt{JNuke\-FieldAccess} and \texttt{JNukeView} using pools.
A \texttt{JNukePool} is a container with a special insert operation: If no equal entry exists in the
pool, it is inserted; otherwise the new entry is automatically destroyed.

\begin{figure}
\begin{center}
\includegraphics[width=\textwidth]{pics/vc_data}
\end{center}
\caption{Pointers of View Consistency to the garbage collected area}\label{fig:vc_data}
\end{figure}

\subsubsection{Analysis}

Objects for fields of views are protected to avoid false positives. Consider figure \ref{fig:vc_objects}.
Logically, it is the safe scenario from figure \ref{fig:safe}, \texttt{q} is only accessed by T0. But if 
If \texttt{q} replaces \texttt{p}, View Consistency mistakes it for the unsafe scenario of figure \ref{fig:high}.

\begin{figure}
\begin{verbatim}
TO:
sync (l) {
  p.x = 0;
  p.y = 0;
}

T1:
sync (m) {
  p.x = 0;
}
// p gets garbage collected and replaced by q
sync (n) {
  q.y = 0;
}
// ...
// warning
\end{verbatim}
\caption{False positive because field object is was not protected}\label{fig:vc_objects}
\end{figure}

\subsubsection{Measures}

Figure \ref{fig:vc_diff} shows how locks (d0, d2) and field objects (d1, d3) are protected.
   
\begin{figure}
\begin{verbatim}
d0 (JNukeViewConsistency_monitorExitListener)
>       new = JNukePool_contains (vc->views, newView) == NULL;
d0 (continued)
>       /* protect lock only if new */
>       if (new)
> 	{
> 	  JNukeGC_protect (JNukeLock_getObject (JNukeView_getLock (newView)));
> 	}
d1 (JNukeViewConsistency_fieldAccessListener)
>   new = JNukePool_contains (vc->fields, field) == NULL;
d1 (continued)
>   /* protect instance only if new */
>   if (new)
>     {
>       JNukeGC_protect (JNukeField_getInstance (field));
>     }
d2 (JNukeViewConsistency_delete)
>   /* release locks */
>   it = JNukePoolIterator (vc->views);
>   while (!JNuke_done (&it))
>     {
>       JNukeGC_release (JNukeLock_getObject
> 		       (JNukeView_getLock (JNuke_next (&it))));
>     }
d3 (JNukeViewConsistency_delete)
>   /* release instances */
>   it = JNukePoolIterator (vc->fields);
>   while (!JNuke_done (&it))
>     {
>       JNukeGC_release (JNukeField_getInstance (JNuke_next (&it)));
>     }
\end{verbatim}
\caption{Changes to \texttt{vc.c}}\label{fig:vc_diff}
\end{figure}

\section{ExitBlock}

ExitBlock \cite{eb} explores schedules in depth-first manner. It first executes one complete schedule of the program,
setting milestones at atomic block boundaries, if more than one thread is ready to run.
Then, it backtracks from the end of the program to the next atomic block boundary, where it
schedules a different thread. This leads to a new schedule branching off from this point in the program.
It repeats this process systematically, continuing to backtrack to atomic block boundaries until
all schedules have been explored \cite{eb}.

ExitBlock-RW records field accesses to prune schedules by avoiding interleaving atomic blocks
that do no share data. For instance, in figure \ref{fig:exitblock_tree} ExitBlock-RW prunes the
schedule that starts with T1 because it remembers from the last execution of T1 that there is no data dependency
between T1 and T0.

\begin{figure}
\begin{center}
\includegraphics{pics/exitblock_tree}
\end{center}
\caption{Schedules explored by ExitBlock and ExitBlock-RW}\label{fig:exitblock_tree}
\end{figure}

\subsection{Data structure}

Only the histories for ExitBlock-RW contain pointers to the heap (see \ref{fig:exitblock_data}).

\begin{figure}
\begin{center}
\includegraphics{pics/exitblock_data}
\end{center}
\caption{Pointers of Eraser to the garbage collected area}\label{fig:exitblock_data}
\end{figure}

\subsection{Analysis}

Field objects of histories must be protected. Suppose, in figure \ref{fig:exitblock_tree}
\texttt{a} was collected and replaced by \texttt{b}. Then, ExitBlock-RW would wrongfully assume that there
is a data dependency between T0 and T1 and explore the same schedules as ExitBlock.

\subsection{Measures}

Field objects are protected when recorded in the history (d4 in figure \ref{fig:exitblock_diff}).
When the history of a thread that resulted from a prior execution is replaced (at rollback),
the field objects of the history being overwritten are released (d1).

ExitBlock triggers the GC externally before taking a footprint (d2).

\begin{figure}
\begin{verbatim}
d1 (JNukeExitBlock_moveHistories)
>       if (history->instances)
>         {
>           hit = JNukeSetIterator (s);
>           while (!JNuke_done (&hit))
>             {
>               JNukeGC_release (JNuke_next (&hit));
>             }
>           JNukeObj_delete (history->instances);
>           history->instances = NULL;
>         }
>     next_thread = JNukeExitBlock_rollback (this);
d2 (JNukeExitBlock_handleLockExit)
>   /*
>    * GC before footprint is taken
>    */
>   JNukeGC_gc (JNukeRuntimeEnvironment_getGC (eBlock->rtenv));
d3 (JNukeExitBlock_getCurrentHistory)
>       if (history->instances == NULL)
>         {
>           history->instances = JNukeSet_new (this->mem);
>           JNukeSet_setType (history->instances, JNukeContentPtr);
>         }
d4 (JNukeExitBlock_onHeapWriteActionListener)
>       if (JNukeSet_insert (history->instances, event->instance))
>         {
>           JNukeGC_protect (event->instance);
>         }
d4 (JNukeExitBlock_onHeapReadActionListener)
>       if (JNukeSet_insert (history->instances, event->instance))
>         {
>           JNukeGC_protect (event->instance);
>         }
\end{verbatim}
\caption{Changes to \texttt{exitblock.c}}\label{fig:exitblock_diff}
\end{figure}

\section{Block-local Atomicity}

Block-local \cite{bla} atomicity needs not be modified because its checks are based on shadow data
managed by the algorithm itself. Therefore, the algorithm does not depend on data on the heap.
The only exception are locks, but they are reachable at \texttt{monitorenter} and \texttt{monitorexit},
which suffices for Block-local atomicity \cite{bla}.

\section{Summary}

Eraser protects locks and field objects to avoid miscalculations.
View Consistency protects locks and field objects. Failing to protect fields could lead to
miscalculations, locks are accessed to generate debugging messages.
ExitBlock needs not to protect data, ExitBlock-RW protects the histories.

\chapter{Experiments}\label{chp:experiments} 

The goal of this chapter is to verify that data is sufficiently protected from the GC
end to measure the performance of the GC.

\section{Sufficient protection}

This section describes how it was verified that the algorithm and the VM sufficiently
protect their data from the GC. The correctness of the GC itself is covered by the unit tests.

When the GC destroys an object that is still in use, a dangling reference is created.
Dereferencing a dangling reference is an illegal memory access. Comparing dangling
references can lead to miscalculations as described in chapter \ref{chp:adaptation}.

\subsection{Always GC}

Illegal memory accesses can safely be detected by Valgrind.
However, if no collection takes place while an object is unprotected, the object
is not destroyed and no illegal memory access occurs.

In "always GC mode" (\texttt{GC=2}), every object creation triggers a collection.
Since a collection takes place every time it potentially takes place with default behavior of the GC,
every potential illegal memory access is bound to occur.

The unit tests for the VM (\texttt{'vm/*/*'}) and the algorithms (\texttt{'rv/*/*'}) were run
"in always GC mode" to verify that data that is later accessed is protected from the GC.

\subsection{Listeners to the GC}

However, comparisons of dangling references cannot safely be detected,
even in "always GC mode". They only cause an error if distinct
pointers are actually assigned the same address (because the first
was freed too early).

Therefore, algorithms must ensure that
there are no dangling references that might be compared.
They register \emph{listeners} to the GC. The GC reports every object it destroys.
The listener checks that it is not an object still in use by the algorithm.
The GC must always collect \texttt{GC=2} and checks must be enabled (option \texttt{CHECKS=1}).

Instead of listeners, \emph{invariants} (stating that all objects in use are live
at any point of execution) could have been implemented.
Invariants would be called after collection (the only time objects are destroyed), rather than for every object.
For every heap reference from the algorithms, invariants would have
to traverse the heap to ensure that the object is still live.
Listeners only traverse the heap references for every object destroyed.
Since the number of objects destroyed is much smaller than the number of
heap objects (especially with frequent collections),
listeners to the GC are more efficient than invariants.

\subsection{Program termination}

The destructor of the GC checks if every object has been released.
The absence of protected objects at program termination does not imply that the objects have been released as soon as possible.
Conversely, the fact that there are protected objects at program termination does imply that they have not been released properly.

\section{Memory and time}

\subsection{Setup}

The test case driver of JNuke measures the time and maximal memory demand of a test.

The GC reports the proportion of time spent in the GC. It measures both the overall time and
the time spent for garbage collection, defined as the time spent in method \texttt{JNukeGC}
and method \texttt{JNukeGC\_onFieldAccess} (where inter-generational references are detected).

Finally, the GC analyzes the number of entries and the overall size of the map of VM states produced by ExitBlock.

The CPU was a 930 MHz Pentium III.

\subsection{Decreasing memory demand}

The effectiveness of garbage collection can be captured by the maximal memory demand of the VM.
Objects the GC reclaims are recycled by the underlying memory manager instead of demanding more
memory from the operating system.

Test \texttt{MergeSort.java} is a na\"{\i}ve implementation of merge sort.
The unsorted array is divided into two arrays, then the sub-arrays are sorted and merged
into the original array. The sub-arrays are recursively divided until their length is one
(in which case nothing is done). Temporary arrays allocated for sorting a sub-array become
garbage when the sub-array has been sorted.
See figure \ref{fig:merge_sort}. The results are listed table \ref{tab:merge_sort}.
With larger arrays the size of the heap becomes predominant for memory usage and garbage collection
makes an impact.

\begin{figure}
\begin{center}
\includegraphics{pics/merge_sort}
\end{center}
\caption{Garbage produced by merge sort}\label{fig:merge_sort}
\end{figure}

\begin{table}
\begin{tabular}{|r|r|r|r|}
\hline
elements & without GC & with GC & time spent in GC \\
\hline
1024 & 948.4 KB & 835.1 KB & 1.2\% \\
\hline
2048 & 1.1 MB & 889.9 KB & 2.5\% \\ 
\hline
4096 & 1.5 MB & 1006.4 KB & 2.2\% \\
\hline
8192 & 2.3 MB & 1.2 MB & 2.9\% \\ 
\hline
16384 & 3.9 MB & 1.6 MB & 2.8\% \\ 
\hline
32768 & 7.3 MB & 2.5 MB & 2.7\% \\
\hline

\end{tabular}
\caption{Test results of merge sort}\label{tab:merge_sort}
\end{table}

\subsection{Infinite programs}

The VM is now be able to execute infinite programs if the data referenced by the program at any time
is limited.
Test \texttt{Infinite.java} infinitely performs the following activity:
It consecutively allocates 6 large blocks of memory, causing its memory usage to grow. Then it releases all 6 blocks.
The allocation of the first block in a cycle triggers a collection (provided the heap size factor is 2;
see chapter \ref{chp:mark_sweep}). At that time, only the first block is referenced by the user program and the 6 blocks
from the previous cycle are garbage collected. The memory usage decreases (see \ref{fig:infinite}).

\begin{figure}
\begin{center}
\includegraphics{pics/infinite}
\end{center}
\caption{Sudden drop in memory usage}\label{fig:infinite}
\end{figure}

The predicted memory usage was observable with \texttt{top}:

\begin{verbatim}
> top -qb | grep testjnuke
28833 pefarkas  15   0  5096 5096   964 R    51.9  0.9  10:06 testjnuke
...
28833 pefarkas  19   0  5096 5096   964 R    48.9  0.9  10:07 testjnuke
28833 pefarkas  16   0  9004 9004   964 R    48.4  1.7  10:07 testjnuke
...
28833 pefarkas  20   0  9004 9004   964 R    49.0  1.7  10:08 testjnuke
28833 pefarkas  18   0  9116 9116   964 R    55.8  1.7  10:08 testjnuke
28833 pefarkas  15   0 12912  12M   964 R    48.6  2.5  10:08 testjnuke
...
28833 pefarkas  20   0 12912  12M   964 R    48.9  2.5  10:09 testjnuke
28833 pefarkas  18   0 16820  16M   964 R    55.9  3.2  10:09 testjnuke
...
28833 pefarkas  20   0 16820  16M   964 R    56.0  3.2  10:10 testjnuke
28833 pefarkas  16   0 20728  20M   964 R    38.7  4.0  10:10 testjnuke
...
28833 pefarkas  18   0 20728  20M   964 R    56.0  4.0  10:11 testjnuke
28833 pefarkas  20   0 24636  24M   964 R    38.7  4.7  10:11 testjnuke
...
28833 pefarkas  16   0 24636  24M   964 R    56.0  4.7  10:12 testjnuke
28833 pefarkas  19   0 28544  27M   964 R    48.4  5.5  10:12 testjnuke
28833 pefarkas  17   0  9004 9004   964 R    55.3  1.7  10:12 testjnuke
28833 pefarkas  19   0  5096 5096   964 R    38.6  0.9  10:12 testjnuke
...
\end{verbatim}

\subsection{Smaller and fewer footprints}

Test \texttt{SwingBaby.java} models a Swing application. A worker works on some task, but the user (the swing thread)
can assign the worker a new task at any time. The worker regularly checks if there is a new task waiting.
If so, it drops the old task and addresses the new one. The worker thread
could be a web browser: when the user selects a link, the browser starts to load the new page immediately.

ExitBlock used to check if the synchronization between the two threads is correct.
The only property currently checked is that the
worker thread always has some task to work on. For ExitBlock, the program needs to be finite,
so the worker takes only four tasks and the user generates only four events.

At program termination, the map of footprints generated by ExitBlock is analyzed without and with GC:

\begin{verbatim}
> tail -2 log/vm/gc/swingBaby.log
ExitBlock produced 4462 footprints taking up 6842160 bytes
0.0% spent in GC
\end{verbatim}

\begin{verbatim}
> tail -2 log/vm/gc/swingBaby.log
ExitBlock produced 4273 footprints taking up 5782528 bytes
7.2% spent in GC
\end{verbatim}

The number of footprints dropped by 4\%; the memory consumed by the footprints by 15\%.

The high number of states with GC shows that there are still many footprints for logically equal states.
The two threads each have a counter that can have four distinct values.
The worker thread enters the monitor twice the user thread once. That would
only amount to 32 states! The large number of footprints for logically equal states is due to pointers in the footprints,
as discussed in chapter \ref{chp:future}. Garbage on the heap is not the only
reason for many footprints, thus the not-so-amazing drop in their number.

\section{Generational GC is more efficient}

First, the GC was non-generational. The non-generational mode is still
available for debugging an profiling.
In both modes, the GC sweeps over only the new generation, but in generational mode it also marks
only new objects (thus it needs to detect inter-generational references).

ExitBlock-RW is run with \texttt{Independent.java}.
Two threads independently append 100 elements to a (thread-local) list.
In every cycle, they pass through a synchronized block to force ExitBlock-RW to set a milestone and
trigger the GC. Because the threads do not share data, ExitBlock-RW prunes many schedules and
the program runs in a reasonable time. The test executed with a generational and the non-generational GC
(option \texttt{GENERATIONAL}).

\begin{verbatim}
> tail -1 log/vm/gc/indep.log
17.8% spent in GC
\end{verbatim}

\begin{verbatim}
> tail -1 log/vm/gc/indep.log
39.9% spent in GC
\end{verbatim}

\section{Summary}

The overhead for garbage collection largely depends on the frequency of collections:
for ExitBlock-RW executed with \texttt{Independent.java},
where a collection takes place in every cycle of tight loop, it was 17.8\%.
while for \texttt{MergeSort.java} it was less than 3\%.
The size of the heap dropped significantly. However, the number of footprints decreased by only 4\%
because of pointers in the footprints.

\chapter{Future work}\label{chp:future}

\section{Making garbage collection more efficient}

\subsection{Generational garbage collection as an optimization}

Only objects created since the last milestone (the new generation) are eligible for
garbage collection. In generational mode, the GC performs both marking and sweeping over only
new objects. The cost of a collection is linear in the size of the new generation, rather than
the size of the heap.

Without milestones, there is only one generation and collections are still performed over the entire heap.
But as "most objects die young" \cite{ungar}, the GC would be more likely to find recyclable objects among the
new ones. The ability of the GC to perform a collection on only new objects could be reused as an
optimization. Other ways would have to be conceived to partition the heap into generations.

\subsection{Protecting less data}

Verification algorithms protect heap objects referenced by pointers they only use for comparison,
thus preventing memory from being recycled and assigned to a logically different pointer.
An alternative to protecting the data would be based on \emph{id}s.

Every every memory bucket returned by \texttt{JNuke\_malloc} has an id. It is the id for the
previously allocated bucket plus one. If ids were unique (which is not the case because they wrap around),
two pointers to buckets would be logically equal iff the ids are equal.
For data they never access, algorithms could hold ids instead of the addresses and would not have
to protect the data.

Interior pointers to Java objects (field descriptors) would pose a problem.
One can see field descriptors as selecting both an object and a field.
But ids only select an object.

\subsection{Reference counting}

Performance could be increased by extending the mark-sweep GC with reference counting. A GC that
relies solely on reference counting is not suitable for Java programs because it does not
reclaim cycles. The fact that an object is garbage does not imply that its reference count is zero.

However, the opposite is always true. Mark-sweep and reference counting could be combined:
Objects whose reference drops to zero (objects not part of a cycle) would be reclaimed
immediately while cycles would be reclaimed later by mark-sweep collection.

\section{Non-ambiguous mapping to footprints}

If every VM state mapped to exactly one footprint, model checking for infinite programs
(with a finite state space) would be possible. With garbage collection,
some footprints merge, because garbage on the heap cannot make the difference between two otherwise
equal footprints. Still, the mapping to footprints is ambiguous because Java reference fields are recorded as addresses.
Thus, footprints depend on the addresses chosen by the memory manager.

For the mapping to be non-ambiguous, the data recorded in the footprints and the order in which they are recorded must
be derivable from the logical state of the VM. The code in figure \ref{fig:non_ambiguous} suggests
how the heap could be recorded replacing references by \emph{ranks}. Every heap object is visited in an order
independent of both the addresses and the order in which they were created. The rank indicates
when the object was visited. The rank uniquely identifies an object, yet is derivable from the logical state.

The question, in which order to record threads would have be to addressed.
The order in which descendants are visited derives from the order of reference fields in the class descriptors.

\begin{figure}
\begin{verbatim}
// find ranks
rank = 0
for all threads
  for all stack frames
     for all registers
       if the register is a reference and object.rank is not set
         object.rank = rank++
         find descendant ranks

// replace references by ranks
for all objects
  for all reference fields
    replace it with destination.rank

record objects sorted by ranks
\end{verbatim}
\caption{Non-ambiguous recording of the heap}\label{fig:non_ambiguous}
\end{figure}

\chapter{Conclusion}\label{chp:conclusion}

A mark-sweep GC was implemented. Copying collection would have naturally eliminated heap
fragmentation. However, data cannot be moved because
verification algorithms hold heap references and changes to the heap are logged
(only differences are saved in the milestones).

Because unreachable objects might become reachable after rollback,
only objects created since the last milestone are considered for collection.
The heap is divided into generations, separated by milestones.
The first, non-generational version of the GC considered the entire heap in the mark phase, but only
the new generation in the sweep phase. The current, generational version 
considers only the new generation in the mark phase, as well.
Because new objects can be reachable only through old objects, the generational version
must detect inter-generation references.

Typed registers were introduced to tell the GC which registers to treat as roots.
Conservative garbage collection (treating every potential reference as a root) was ruled
out because an erroneously saved object might make up the difference between two footprints.

The verification algorithms were adapted to protect objects they reference from the GC.
Data referred to by the algorithms has to be protected even if it is never accessed
(the pointer is never dereferenced), in order to avoid the memory from being
recycled and assigned to a logically different pointer. If heap objects had unique ids,
ids could replace references and less data would need to be protected. Copying
collection could then be reconsidered.

Experiments showed a significant drop in the size of the heap.
The decrease in the number of footprints, however, was only slight because the mapping of
VM states to footprints is ambiguous due to pointers in the footprints.
The generational GC outperforms the non-generational one, but since only
very small programs can be model-checked due to the poor mapping to footprints,
generational garbage collection must be seen as a preparation for the
future.

Still, garbage collection was a step toward non-ambiguous mapping to footprints.
If the mapping was non-ambiguous, model checking would be much more efficient.
Checking infinite programs (with a limited state space) would be possible.

\appendix

\chapter{Santa Claus Benchmark}

This appendix has been added by Cyrille Artho after project completion.

\listinginput{1}{../../log/vm/rtenvironment/classpath/santa/SantaClaus.java}

\begin{thebibliography}{99}
\bibitem{jnuke} P. Eugster. Java Virtual Machine with rollback procedure allowing systematic and
exhaustive testing of multi-threaded Java programs. Master thesis, ETH Zurich, 2003.
\bibitem{bmc} Bounded Model Checking.
A. Biere, A. Cimatti, E. Clarke, O. Strichman, and Y. Zhu. In Advances in Computers, volume 58, 2003.
\bibitem{eraser} S. Savage, M. Burrows, G. Nelson, P. Sobalvarro, and T. Anderson.
Eraser: A Dynamic Data Race Detector for Multi-threaded Programs. ACM Transactions on Computer Systems, 15(4):391 411, 1997.
\bibitem{vc} C. Artho, K. Havelund, and A. Biere. High-level Data Races. In: Journal on Software Testing, Verification and Reliability (STVR), 13(4).
Extended Version of the VVEIS '03 paper.
\bibitem{eb} D. Bruening. Systematic Testing of Multi-threaded Java Programs. Master thesis, MIT, 1999.
\bibitem{bla} C. Artho, K. Havelund, A. Biere: Using Block-local Atomicity to Detect Stale-value Concurrency Errors.
ATVA '04, Taipei, Taiwan, November 2004.
\bibitem{jones} Garbage collection: algorithms for automatic dynamic memory management. Richard Jones, Rafael Lins
(ISBN: 0-471-94148-4).
\bibitem{ungar} D. M. Ungar. Generation scavenging: A nondisruptive high performance storage reclamation algorithm.
ACM SIGPLAN Notices, 19(5):157--167, April 1984.
\bibitem{appel} Andrew W. Appel. Simple generational garbage collection and fast allocation.
Software Practice and Experience, 19(2):171-183, 1989.
\bibitem{mono} www.go-mono.com
\bibitem{kaffe} www.kaffe.org
\end{thebibliography}
\end{document}
